{***************************************************************************}
{*                                                                         *}
{*                       p  PKT 䠩.                    *}
{*                                                                         *}
{*      Copyright (c) 1996 by Alexander S. Tokareff, 2:5077/27@Fidonet     *}
{*                                                                         *}
{***************************************************************************}
Unit Pkts;
Interface
Uses Objects, Defs;
Type
 PPktParent = ^TPktParent;
 TPktParent = object(TObject)
  procedure Store(var S : TStream); virtual;
 end;

 PPktHeader = ^TPktHeader;
 TPktHeader = object(TPktParent)
  OrigNode, DestNode, Year, Month, Day, Hour, Minute, Second, Baud, Version,
  OrigNet, DestNet : word;
  ProdCode : byte;

  constructor Init(var S : TStream);
  constructor Create(AOrigNode, ADestNode, AYear, AMonth, ADay, AHour,
                     AMinute, ASecond, ABaud, AOrigNet, ADestNet : word);
  destructor Done; virtual;

  function GetOrigNode : word;
  function GetDestNode : word;
  function GetYear : word;
  function GetMonth : word;
  function GetDay : word;
  function GetHour : word;
  function GetMinute : word;
  function GetSecond : word;
  function GetOrigNet : word;
  function GetDestNet : word;
  function GetProdCode : byte;

  procedure Store(var S : TStream); virtual;
 end;

 PPktMsg = ^TPktMsg;
 TPktMsg = object(TPktParent)
  OrigNode, DestNode, OrigNet, DestNet, Attr, Cost : word;
  Date : DateTime;
  Too  : String36;
  From : String36;
  Subject : String72;
  TextMsg : PTextBuffer;

  constructor Init(var S : TStream);
  constructor Create(AOrigNode, ADestNode, AOrigNet, ADestNet, AAttr : word;
                     ADate, AToo, AFrom, ASubject : string;
                     ATextMsg : PTextBuffer; ATextLen : longint);
  destructor Done; virtual;

  function GetOrigNode : word;
  function GetDestNode : word;
  function GetOrigNet : word;
  function GetDestNet : word;
  function GetAttr : word;
  function GetDate : string;
  function GetToo : string;
  function GetFrom : string;
  function GetSubject : string;
  function GetTextMsg : PTextBuffer;
  function GetTextLen : longint;

  procedure Store(var S : TStream); virtual;
 private
  TextLen : longint;
 end;

 PNulMsg = ^TNulMsg;
 TNulMsg = object(TPktParent)
  procedure Store(var S : TStream); virtual;
 end;

 PPktCollection = ^TPktCollection;
 TPktCollection = object(TCollection)
  constructor Init(var S : TStream);
  constructor Create(AMsg : PPktMsg);
  destructor Done; virtual;

  procedure Store(var S : TStream);
 end;

 PPacket = ^TPacket;
 TPacket = object(TPktParent)
  Header : PPktHeader;
  Messages : PPktCollection;
  EndMsg : PNulMsg;

  constructor Init(var S : TStream);
  constructor Create(var AHeader : PPktHeader; var AMsgs : PPktCollection);
  destructor Done; virtual;

  procedure Store(var S : TStream); virtual;
 end;

Implementation

 procedure TPktParent.Store;
 begin
 end;

 constructor TPktHeader.Init;
 begin
  with S do
  begin
   Seek(0);
   Read(OrigNode, 25);
   Seek(GetPos + 33);
  end;
 end;

 constructor TPktHeader.Create;
 begin
  OrigNode := AOrigNode; DestNode := ADestNode; OrigNet := AOrigNet;
  DestNet := ADestNet; Year := AYear; Month := AMonth; Day := ADay;
  Hour := AHour; Minute := AMinute; Second := ASecond; Baud := ABaud;
  Version := $0002; ProdCode := 2;
 end;

 destructor TPktHeader.Done;
 begin
  inherited Done;
 end;

 function TPktHeader.GetOrigNode;
 begin
  GetOrigNode := OrigNode;
 end;

 function TPktHeader.GetDestNode;
 begin
  GetDestNode := DestNode;
 end;

 function TPktHeader.GetYear;
 begin
  GetYear := Year;
 end;

 function TPktHeader.GetMonth;
 begin
  GetMonth := Month;
 end;

 function TPktHeader.GetDay;
 begin
  GetDay := Day;
 end;

 function TPktHeader.GetHour;
 begin
  GetHour := Hour;
 end;

 function TPktHeader.GetMinute;
 begin
  GetMinute := Minute;
 end;

 function TPktHeader.GetSecond;
 begin
  GetSecond := Second;
 end;

 function TPktHeader.GetOrigNet;
 begin
  GetOrigNet := OrigNet;
 end;

 function TPktHeader.GetDestNet;
 begin
  GetDestNet := DestNet;
 end;

 function TPktHeader.GetProdCode;
 begin
  GetProdCode := ProdCode;
 end;

 procedure TPktHeader.Store;
 begin
  with S do
  begin
   Seek(0);
   Truncate;
   Write(OrigNode, 25);
   Write(Fill33, 33);
  end;
 end;

 constructor TPktMsg.Init;
 var
  w : word;
  c : char;
  beginpos, endpos, l : longint;
 begin
  Too := ''; From := ''; Subject := '';
  with S do
  begin
   Read(w, 2);
   if w = 0 then Exit;
   Read(OrigNode, 12);
   Date[0] := Chr(20);
   Read(Date[1], 20);
   while c <> #0 do
   begin
    Read(c, 1);
    Too := Too + c;
   end;
   c := #255;
   while c <> #0 do
   begin
    Read(c, 1);
    From := From + c;
   end;
   c := #255;
   while c <> #0 do
   begin
    Read(c, 1);
    Subject := Subject + c;
   end;
   c := #255;
   beginpos := GetPos;
   while c <> #0 do
    Read(c, 1);
   endpos := GetPos;
   TextLen := endpos - beginpos;
   GetMem(TextMsg, TextLen);
   Seek(beginpos);
   Read(TextMsg^, TextLen);
  end;
 end;

 constructor TPktMsg.Create;
 begin
  if TextMsg <> nil then FreeMem(TextMsg, TextLen);
  OrigNode := AOrigNode; DestNode := ADestNode; OrigNet := AOrigNet;
  DestNet := ADestNet; Attr := AAttr; Date := ADate;
  Too := Copy(AToo, 1, 35) + #0;
  From := Copy(AFrom, 1, 35) + #0;
  Subject := Copy(ASubject, 1, 71) + #0;
  TextMsg := ATextMsg;
  TextLen := ATextLen;
 end;

 destructor TPktMsg.Done;
 begin
  if TextMsg <> nil then FreeMem(TextMsg, TextLen);
  inherited Done;
 end;

 function TPktMsg.GetOrigNode;
 begin
  GetOrigNode := OrigNode;
 end;

 function TPktMsg.GetDestNode;
 begin
  GetDestNode := DestNode;
 end;

 function TPktMsg.GetOrigNet;
 begin
  GetOrigNet := OrigNet;
 end;

 function TPktMsg.GetDestNet;
 begin
  GetDestNet := DestNet;
 end;

 function TPktMsg.GetAttr;
 begin
  GetAttr := Attr;
 end;

 function TPktMsg.GetDate;
 begin
  GetDate := Date;
 end;

 function TPktMsg.GetToo;
 begin
  GetToo := Too;
 end;

 function TPktMsg.GetFrom;
 begin
  GetFrom := From;
 end;

 function TPktMsg.GetSubject;
 begin
  GetSubject := Subject;
 end;

 function TPktMsg.GetTextMsg;
 begin
  GetTextMsg := TextMsg;
 end;

 function TPktMsg.GetTextLen;
 begin
  GetTextLen := TextLen;
 end;

 procedure TPktMsg.Store;
 var
  w : word;
 begin
  with S do
  begin
   w := $0002;
   Write(w, 2);
   Write(OrigNode, 12);
   Write(Date[1], 20);
{   if Too[Length(Too)] <> #0 then Too := Too + #0;}
   Write(Too[1], Ord(Too[0]) - 1);
{   if From[Length(From)] <> #0 then From := From + #0;}
   Write(From[1], Ord(From[0]) - 1);
{   if Subject[Length(Subject)] <> #0 then Subject := Subject + #0;}
   Write(Subject[1], Ord(Subject[0]) - 1);
   Write(TextMsg^, TextLen);
  end;
 end;

 procedure TNulMsg.Store;
 var
   nul : word;
 begin
  nul := $0000;
  S.Write(nul, 2);
 end;

 constructor TPktCollection.Init;
 var
  pos : longint;
  msg : PPktMsg;
 begin
  inherited Init(10, 10);
  pos := S.GetSize - 2;
  while S.GetPos <> pos do
  begin
   msg := New(PPktMsg, Init(S));
   Insert(msg);
  end;
 end;

 constructor TPktCollection.Create;
 begin
  inherited Init(10, 10);
  if AMsg <> nil then Insert(AMsg);
 end;

 destructor TPktCollection.Done;
 begin
  inherited Done;
 end;

 procedure TPktCollection.Store;

  procedure StoreItem(P : pointer); far;
  begin
   PPktParent(P)^.Store(S);
  end;

 begin
  ForEach(@StoreItem);
 end;

 constructor TPacket.Init;
 begin
  inherited Init;
  Header := New(PPktHeader, Init(S));
  Messages := New(PPktCollection, Init(S));
  EndMsg := New(PNulMsg, Init);
 end;

 constructor TPacket.Create;
 begin
  inherited Init;
  if AHeader <> nil then Header := AHeader;
  if AMsgs <> nil then Messages := AMsgs;
  EndMsg := New(PNulMsg, Init);
 end;

 destructor TPacket.Done;
 begin
  if Header <> nil then Dispose(Header, Done);
  if Messages <> nil then Dispose(Messages, Done);
  if EndMsg <> nil then Dispose(EndMsg, Done);
  inherited Done;
 end;

 procedure TPacket.Store;
 begin
  Header^.Store(S);
  Messages^.Store(S);
  EndMsg^.Store(S);
 end;

End.
